<!--#include file="FusionWebRequest.asp"-->
<!--#include file="FusionTableJSONParser.asp"-->
<%
Const NUMBER_OF_TRIES = 3
Const THROTTLE_WAIT_TIME = 1

Class FusionTableWrapper
    Private sUsername
    Private sPassword
    Private sAPIKey
    Private sAuth

    public Function WebRequestTest()
        Dim webRequest
        Set webRequest = New FusionWebRequest

        Response.Write(webRequest.GETRequest())
    End Function

    Public Function Create(apiKey)
        sAPIKey = apiKey
    End Function

    Public Function CreateWithCredentials(username, password)
        call Err.Raise(600001, "FusionTableWrapper.asp", "Not Supported")
    End Function

    Public Function ExecuteQuery(query)
        Set ExecuteQuery = Nothing
        Dim queryLower
        Dim retries
        Dim retry

        queryLower = LCase(LTrim(query))

        If (Left(queryLower, 6) = "select" Or Left(queryLower, 4) = "show" Or Left(queryLower, 8) = "describe") Then
            Dim results
            Dim rs
            Dim csvParser
            Dim webRequest
            Set webRequest = New FusionWebRequest
            retry = False
            retries = 1

            Do
                If (retry) Then
                    Sleep(THROTTLE_WAIT_TIME)
                    retries = retries + 1
                End if
                results = webRequest.GETRequest(query, apiKey, retry)
            Loop While (results = "" And retry And retries < NUMBER_OF_TRIES)

            If (results <> "") Then
                Set csvParser = New FusionTableJSONParser
                Set ExecuteQuery = csvParser.GetData(results)
            End If
        Else
            Call Err.Raise(60001, "FusionTableWrapper.asp", "Not Supported Command")
        End If
    End Function

    Private Sub Sleep(intSecs)
        Dim dtStart, boolDone
        dtStart = now()
        boolDone = False
        While Not boolDone
            If DateDiff("s", dtStart,now()) >= cint(intSecs) Then
                boolDone = True
            End If
        Wend
    End Sub

End Class
%>