<%
Const FUSIONTABLE_ENDPOINT = "https://www.googleapis.com/fusiontables/v1/query"
Const GOOGLE_OAUTH2_ENDPOINT = "https://accounts.google.com/o/oauth2/token"
Const TOKENVALIDFOR = 3600

Class FusionWebRequest

    Public Function GETRequest(query, apiKey, ByRef retry)
        retry = false
        DIM ret, formData, paramStr, req, xmlhttp
        
        ret = ""
        SET formData = CreateObject("Scripting.Dictionary")
        formData.Add "sql", query
        formData.Add "key", apiKey
        
        paramStr = FormURLParam(formData) 
        req = FUSIONTABLE_ENDPOINT & paramStr        
         
        Set xmlhttp = Server.Createobject("MSXML2.ServerXMLHTTP")
		xmlhttp.Open "GET", req, false
		xmlhttp.Send

		If (xmlhttp.Status = 200) Then
			Dim responseText
			responseText = xmlhttp.ResponseText
			If (LCase(Left(responseText, 5)) = "<html") Then
				ret = ""
				Call Err.Raise(60000, "FusionWebRequest.asp", "Google redirected your request - Please check that you are authenticated, or that you are querying a public table.")
			Else
				ret = responseText
				retry = (responseText = "")
			End If
		ElseIf (xmlhttp.Status = 400) Then '' Bad Request
			Call Err.Raise(60000, "FusionWebRequest.asp", "Google says that your request was not valid - Please check your query. Message from Google: " & xmlhttp.StatusText)
		Else
			Call Err.Raise(60000, "FusionWebRequest.asp", "Google responded with an error. Message from Google: " & xmlhttp.StatusText)
		End If

		Set xmlhttp = nothing

		GETRequest = ret        
    End Function
    
    
 
    Private Function FormURLParam(form)
        DIM outout
        output = ""
        
        For Each key in form
            output = output & Server.URLEncode(key) & "=" & Server.URLEncode(form.Item(key)) & "&"
        Next
        
        If Len(output) > 0 Then
            output = "?" & Left(output, Len(output)-1) 
        End if
        FormURLParam = output
    End Function
    
End Class

Class GoogleOAUTH2ServiceAccount
    Public Function GetAccessToken(email, certificatePath, isReadWrite)
        Call Err.Raise(60001, "FusioWebRequest.asp", "Not supported")
    End Function
End Class

%>