﻿using System;

public class GoogleFusionSupport
{
    #region " gftExecuteWithRetry "
    /// <summary>
    /// Execute a query using Google Fusion tables.  Automatically retry the query 5 times.
    /// </summary>
    /// <param name="SqlQuery">The SQL Query to execute</param>
    public static System.Data.DataTable gftExecuteWithRetry(string SqlQuery)
    {
        for (Int32 retry_count = 0; retry_count <= 5; retry_count++)
        {
            try
            {
                return gftExecuteOnce(SqlQuery);
            }
            catch
            {
                //whatever...try again
            }
        }

        //No just crash normally
        return gftExecuteOnce(SqlQuery);
    }

    /// <summary>
    /// Execute a query using Google Fusion tables.  Automatically retry the query 5 times.
    /// </summary>
    /// <typeparam name="T">The typed datatable type to use</typeparam>
    /// <param name="SqlQuery">The SQL Query to execute</param>
    public static T gftExecuteWithRetry<T>(string SqlQuery) where T : System.Data.DataTable, new()
    {
        System.Data.DataTable dtBase = gftExecuteWithRetry(SqlQuery);

        T dtTyped = new T();
        dtTyped.Merge(dtBase);

        return dtTyped;
    }


    private static System.Data.DataTable gftExecuteOnce(string SqlQuery)
    {
        GoogleFusionTableWrapperNET.FusionTableWrapper gft = new GoogleFusionTableWrapperNET.FusionTableWrapper(Resources.SqlQueries.GoogleApiKey);

        return gft.ExecuteQuery(SqlQuery);
    }


    #endregion
}