﻿using System;
using System.Web.UI.WebControls;

public partial class boating : System.Web.UI.Page
{
    #region " Page_PreRender "
    //For checking column names
    private static dsMain.BoatingDataTable dtTemplate = new dsMain.BoatingDataTable();

    private void Page_PreRender(object sender, EventArgs e) //AutoEventWireup
    {
        string qsId = Request.QueryString["id"];
        datalist.Visible = qsId == null;

        Master.MapScriptEnabled = !datalist.Visible;
        phMap.Visible = !datalist.Visible;

        //Choose Page Title depending on mode
        Master.PageTitle = Master.PageTitle.Split('|')[datalist.Visible ? 0 : 1];

        if (datalist.Visible)
        {
            //List Mode
            string sql = string.Format(Resources.SqlQueries.sqlGenericList, Resources.SqlQueries.TableBoatingFacility, Master.data_Lat, Master.data_Lng, 10);

            datalist.DataSource = GoogleFusionSupport.gftExecuteWithRetry<dsMain.BoatingDataTable>(sql);
            datalist.ItemDataBound += datalist_ItemDataBound;
            datalist.DataBind();
        }
        else
        {
            //Map Detail Mode
            string sql = string.Format(Resources.SqlQueries.sqlGenericDetail, Resources.SqlQueries.TableBoatingFacility, dtTemplate.FACILITYIDColumn.ColumnName, qsId);

            dsMain.BoatingDataTable dt = GoogleFusionSupport.gftExecuteWithRetry<dsMain.BoatingDataTable>(sql);

            if (dt != null && dt.Rows.Count > 0)
            {
                dsMain.BoatingRow dr = dt[dt.Rows.Count - 1];

                string lat = dr.LATITUDE;
                string lng = dr.LONGITUDE;

                Master.PageBody.Attributes["onload"] = string.Format("set_map({0},{1},{2},{3});", 14, lat, lng, "'map_canvas'");

                litName.Text = dr.FACILITY_NAME;
                litAddress.Text = dr.FACILITY_ADDRESS;
                litCity.Text = dr.CITY;
                litZip.Text = dr.ZIPCODE;
                lnkTel.NavigateUrl = string.Format(lnkTel.NavigateUrl, dr.PHONE_NUM);
                lnkTel.Text = string.Format(lnkTel.Text, dr.PHONE_NUM);
            }
        }
    }
    #endregion

    #region " datalist_ItemDataBound "
    // (You could move this to a common location and reuse this if your detail rows look the same)
    private static void datalist_ItemDataBound(object sender, System.Web.UI.WebControls.RepeaterItemEventArgs e)
    {
        switch (e.Item.ItemType)
        {
            case System.Web.UI.WebControls.ListItemType.Header:
            case System.Web.UI.WebControls.ListItemType.Footer:
                return;
        }

        dsMain.BoatingRow dr = (dsMain.BoatingRow)((System.Data.DataRowView)e.Item.DataItem).Row;

        HyperLink lnk = (HyperLink)e.Item.FindControl("lnk");
        if (lnk != null)
        {
            lnk.NavigateUrl = string.Format(lnk.NavigateUrl, dr.FACILITYID);
        }

        var _with2 = (Literal)e.Item.FindControl("litName");
        _with2.Text = dr.FACILITY_NAME;
        var _with3 = (Literal)e.Item.FindControl("litAddress");
        _with3.Text = dr.FACILITY_ADDRESS;
        var _with4 = (Literal)e.Item.FindControl("litCity");
        _with4.Text = dr.CITY;
        var _with5 = (Literal)e.Item.FindControl("litZip");
        _with5.Text = dr.ZIPCODE;
    }
    #endregion
}