﻿using System;
using System.Web.UI.WebControls;

public partial class _default : System.Web.UI.Page
{
    #region " Page_Init, GetMapScript "
    private void Page_Init(object sender, EventArgs e)
    {
        Master.IsHomePage = true;
        Master.MapScriptEnabled = true;

        //Prepare map execution
        Master.PageBody.Attributes["onload"] = "initialize()";

        litInitScript.Text += "<script type='text/javascript'>" + Environment.NewLine;
        litInitScript.Text += "function initialize() {" + Environment.NewLine;
        litInitScript.Text += string.Format("var map_center = new google.maps.LatLng({0},{1});", Master.data_Lat, Master.data_Lng) + Environment.NewLine;


        //Init values for each map
        //Map #1
        {
            string sql = string.Format(Resources.SqlQueries.sqlGenericList, Resources.SqlQueries.TableBoatingFacility, Master.data_Lat, Master.data_Lng, 3);
            dsMain.BoatingDataTable dt = GoogleFusionSupport.gftExecuteWithRetry<dsMain.BoatingDataTable>(sql);
            litInitScript.Text += GetMapScript(dt, 1, dt.LATITUDEColumn, dt.LONGITUDEColumn);

            mapDetail1.DataSource = dt;
            mapDetail1.ItemDataBound += mapDetail1_ItemDataBound;
            mapDetail1.DataBind();
        }
        //Map #2
        //{
        //    string sql = string.Format(Resources.SqlQueries.sqlGenericList, Resources.SqlQueries.TableBoatingFacility, Master.data_Lat, Master.data_Lng, 3);
        //    dsMain.BoatingDataTable dt = GoogleFusionSupport.gftExecuteWithRetry<dsMain.BoatingDataTable>(sql);
        //    litInitScript.Text += GetMapScript(dt, 2, dt.LATITUDEColumn, dt.LONGITUDEColumn);

        //    mapDetail2.DataSource = dt;
        //    mapDetail2.ItemDataBound += mapDetail2_ItemDataBound;
        //    mapDetail2.DataBind();
        //}

        litInitScript.Text += "}" + Environment.NewLine;
        litInitScript.Text += "</script>" + Environment.NewLine;
    }

    private static string GetMapScript(System.Data.DataTable dt, Int32 MapIndex, System.Data.DataColumn LatColumn, System.Data.DataColumn LngColumn)
    {
        string InitScript = string.Format("var map{0} = InitMap('map_canvas{0}', 11, map_center);", MapIndex) + Environment.NewLine;

        foreach (System.Data.DataRow dr in dt.Rows)
        {
            InitScript += string.Format("AddMarker({1}, {2}, map{0})", MapIndex, dr[LatColumn], dr[LngColumn]) + Environment.NewLine;
        }

        return InitScript;
    }
    #endregion

    #region " mapDetail1_ItemDataBound "
    // (You could move this to a common location and reuse this if your detail rows look the same)
    private static void mapDetail1_ItemDataBound(object sender, System.Web.UI.WebControls.RepeaterItemEventArgs e)
    {
        switch (e.Item.ItemType)
        {
            case System.Web.UI.WebControls.ListItemType.Header:
            case System.Web.UI.WebControls.ListItemType.Footer:
                return;
        }

        dsMain.BoatingRow dr = (dsMain.BoatingRow)((System.Data.DataRowView)e.Item.DataItem).Row;

        dynamic lnk = (HyperLink)e.Item.FindControl("lnk");
        if (lnk != null)
        {
            lnk.NavigateUrl = string.Format(lnk.NavigateUrl, dr.FACILITYID);
        }

        var _with2 = (Literal)e.Item.FindControl("litName");
        _with2.Text = dr.FACILITY_NAME;
        var _with3 = (Literal)e.Item.FindControl("litAddress");
        _with3.Text = dr.FACILITY_ADDRESS;
        var _with4 = (Literal)e.Item.FindControl("litCity");
        _with4.Text = dr.CITY;
        var _with5 = (Literal)e.Item.FindControl("litZip");
        _with5.Text = dr.ZIPCODE;
    }
    #endregion
}