﻿#Region " Compiler Options "
Option Strict On
Option Explicit On
Option Compare Binary
Option Infer On
#End Region

Partial Public Class boating
    Inherits System.Web.UI.Page

#Region " Page_PreRender "
    Private Shared dtTemplate As New dsMain.BoatingDataTable 'For checking column names

    Private Sub Page_PreRender(sender As Object, e As EventArgs) Handles Me.PreRender
        Dim qsId = Request.QueryString("id")
        datalist.Visible = qsId Is Nothing

        Master.MapScriptEnabled = Not datalist.Visible
        phMap.Visible = Not datalist.Visible

        'Choose Page Title depending on mode
        Master.PageTitle = Master.PageTitle.Split("|"c)(If(datalist.Visible, 0, 1))

        If datalist.Visible Then
            'List Mode
            Dim sql = String.Format(Resources.SqlQueries.sqlGenericList, Resources.SqlQueries.TableBoatingFacility, Master.data_Lat, Master.data_Lng, 10)

            datalist.DataSource = GoogleFusionSupport.gftExecuteWithRetry(Of dsMain.BoatingDataTable)(sql)
            datalist.DataBind()
        Else
            'Map Detail Mode
            Dim sql = String.Format(Resources.SqlQueries.sqlGenericDetail, Resources.SqlQueries.TableBoatingFacility, dtTemplate.FACILITYIDColumn.ColumnName, qsId)

            Dim dt = GoogleFusionSupport.gftExecuteWithRetry(Of dsMain.BoatingDataTable)(sql)

            If dt IsNot Nothing AndAlso dt.Rows.Count > 0 Then
                Dim dr = dt(dt.Rows.Count - 1)

                Dim lat = dr.LATITUDE
                Dim lng = dr.LONGITUDE

                Master.PageBody.Attributes("onload") = String.Format("set_map({0},{1},{2},{3});", 14, lat, lng, "'map_canvas'")

                litName.Text = dr.FACILITY_NAME
                litAddress.Text = dr.FACILITY_ADDRESS
                litCity.Text = dr.CITY
                litZip.Text = dr.ZIPCODE
                lnkTel.NavigateUrl = String.Format(lnkTel.NavigateUrl, dr.PHONE_NUM)
                lnkTel.Text = String.Format(lnkTel.Text, dr.PHONE_NUM)
            End If
        End If
    End Sub
#End Region

#Region " datalist_ItemDataBound "
    ' (You could move this to a common location and reuse this if your detail rows look the same)
    Private Sub datalist_ItemDataBound(sender As Object, e As System.Web.UI.WebControls.RepeaterItemEventArgs) Handles datalist.ItemDataBound
        Select Case e.Item.ItemType
            Case ListItemType.Header, ListItemType.Footer
                Exit Sub
        End Select

        Dim dr = DirectCast(DirectCast(e.Item.DataItem, Data.DataRowView).Row, dsMain.BoatingRow)

        Dim lnk = DirectCast(e.Item.FindControl("lnk"), HyperLink)
        If lnk IsNot Nothing Then
            lnk.NavigateUrl = String.Format(lnk.NavigateUrl, dr.FACILITYID)
        End If

        With DirectCast(e.Item.FindControl("litName"), Literal)
            .Text = dr.FACILITY_NAME
        End With
        With DirectCast(e.Item.FindControl("litAddress"), Literal)
            .Text = dr.FACILITY_ADDRESS
        End With
        With DirectCast(e.Item.FindControl("litCity"), Literal)
            .Text = dr.CITY
        End With
        With DirectCast(e.Item.FindControl("litZip"), Literal)
            .Text = dr.ZIPCODE
        End With
    End Sub
#End Region
End Class
