﻿#Region " Compiler Options "
Option Strict On
Option Explicit On
Option Compare Binary
Option Infer On
#End Region

Partial Public Class _default
    Inherits System.Web.UI.Page

#Region " Page_Init, GetMapScript "
    Private Sub Page_Init(sender As Object, e As EventArgs) Handles Me.Init
        Master.IsHomePage = True
        Master.MapScriptEnabled = True

        'Prepare map execution
        Master.PageBody.Attributes("onload") = "initialize()"

        litInitScript.Text &= "<script type='text/javascript'>" & Environment.NewLine
        litInitScript.Text &= "function initialize() {" & Environment.NewLine
        litInitScript.Text &= String.Format("var map_center = new google.maps.LatLng({0},{1});", Master.data_Lat, Master.data_Lng) & Environment.NewLine


        'Init values for each map
        'Map #1
        With mapDetail1
            Dim sql = String.Format(Resources.SqlQueries.sqlGenericList, Resources.SqlQueries.TableBoatingFacility, Master.data_Lat, Master.data_Lng, 3)
            Dim dt = GoogleFusionSupport.gftExecuteWithRetry(Of dsMain.BoatingDataTable)(sql)
            litInitScript.Text &= GetMapScript(dt, 1, dt.LATITUDEColumn, dt.LONGITUDEColumn)

            .DataSource = dt
            .DataBind()
        End With

        'Map #2
        'With mapDetail2
        '    Dim sql = String.Format(Resources.SqlQueries.sqlGenericList, Resources.SqlQueries.TableBoatingFacility, Master.data_Lat, Master.data_Lng, 3)
        '    Dim dt = GoogleFusionSupport.gftExecuteWithRetry(Of dsMain.BoatingDataTable)(sql)
        '    litInitScript.Text &= InitMap(dt, 2, mapDetail2, dt.LATITUDEColumn, dt.LONGITUDEColumn)
        '    .DataSource = dt
        '    .DataBind()
        'End With

        litInitScript.Text &= "}" & Environment.NewLine
        litInitScript.Text &= "</script>" & Environment.NewLine
    End Sub

    Private Shared Function GetMapScript(dt As Data.DataTable, MapIndex As Int32, LatColumn As Data.DataColumn, LngColumn As Data.DataColumn) As String
        Dim InitScript = String.Format("var map{0} = InitMap('map_canvas{0}', 11, map_center);", MapIndex) & Environment.NewLine

        For Each dr As Data.DataRow In dt.Rows
            InitScript &= String.Format("AddMarker({1}, {2}, map{0})", MapIndex, dr(LatColumn), dr(LngColumn)) & Environment.NewLine
        Next

        Return InitScript
    End Function
#End Region

#Region " mapDetail1_ItemDataBound "
    ' (You could move this to a common location and reuse this if your detail rows look the same)
    Private Shared Sub mapDetail1_ItemDataBound(sender As Object, e As System.Web.UI.WebControls.RepeaterItemEventArgs) Handles mapDetail1.ItemDataBound
        Select Case e.Item.ItemType
            Case ListItemType.Header, ListItemType.Footer
                Exit Sub
        End Select

        Dim dr = DirectCast(DirectCast(e.Item.DataItem, Data.DataRowView).Row, dsMain.BoatingRow)

        Dim lnk = DirectCast(e.Item.FindControl("lnk"), HyperLink)
        If lnk IsNot Nothing Then
            lnk.NavigateUrl = String.Format(lnk.NavigateUrl, dr.FACILITYID)
        End If

        With DirectCast(e.Item.FindControl("litName"), Literal)
            .Text = dr.FACILITY_NAME
        End With
        With DirectCast(e.Item.FindControl("litAddress"), Literal)
            .Text = dr.FACILITY_ADDRESS
        End With
        With DirectCast(e.Item.FindControl("litCity"), Literal)
            .Text = dr.CITY
        End With
        With DirectCast(e.Item.FindControl("litZip"), Literal)
            .Text = dr.ZIPCODE
        End With
    End Sub
#End Region
End Class
